// treedump.h
#include <stdio.h>
#include <stdint.h>
#include <string.h>
#include <dirent.h>
#include <sys/stat.h>   //_CRTIMP int __cdecl __MINGW_NOTHROW  _stati64(const char *, struct _stati64 *);

//const int IS_DIR_FLAG = 1, IS_FILE_FLAG = 2;
char llTOaDigits[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
char llTOaDigits2[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
//char llTOaDigits3[27]; // 9,223,372,036,854,775,807: 1(sign or carry)+19(digits)+1('\0')+6(,)
//printf( "Size of input file: %s\n",  _ui64toaKAZEcomma(size_in64, llTOaDigits, 10));
//printf( "%s Lines Found: %s; \n", Auberge[Melnitchka++], _ui64toaKAZEzerocomma(Over4billionLines, llTOaDigits, 10)+(26-15));

void x64toaKAZE_duplicat (      /* stdcall is faster and smaller... Might as well use it for the helper. */
        unsigned long long val,
        char *buf,
        unsigned radix,
        int is_neg
        )
{
        char *p;                /* pointer to traverse string */
        char *firstdig;         /* pointer to first digit */
        char temp;              /* temp char */
        unsigned digval;        /* value of digit */

        p = buf;

        if ( is_neg )
        {
            *p++ = '-';         /* negative, so output '-' and negate */
            val = (unsigned long long)(-(long long)val);
        }

        firstdig = p;           /* save pointer to first digit */

        do {
            digval = (unsigned) (val % radix);
            val /= radix;       /* get next digit */

            /* convert to ascii and store */
            if (digval > 9)
                *p++ = (char) (digval - 10 + 'a');  /* a letter */
            else
                *p++ = (char) (digval + '0');       /* a digit */
        } while (val > 0);

        /* We now have the digit of the number in the buffer, but in reverse
           order.  Thus we reverse them now. */

        *p-- = '\0';            /* terminate string; p points to last digit */

        do {
            temp = *p;
            *p = *firstdig;
            *firstdig = temp;   /* swap *p and *firstdig */
            --p;
            ++firstdig;         /* advance to next two digits */
        } while (firstdig < p); /* repeat until halfway */
}

/* Actual functions just call conversion helper with neg flag set correctly,
   and return pointer to buffer. */

char * _i64toaKAZE_duplicat (
        long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE_duplicat((unsigned long long)val, buf, radix, (radix == 10 && val < 0));
        return buf;
}

char * _ui64toaKAZE_duplicat (
        unsigned long long val,
        char *buf,
        int radix
        )
{
        x64toaKAZE_duplicat(val, buf, radix, 0);
        return buf;
}

char * _ui64toaKAZEzerocomma_duplicat (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE_duplicat(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        do
                        { if (buf <= p)
                          { temp = *p;
                            buf[26-txpman] = temp; pxnman++;
                            p--;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          else
                          { buf[26-txpman] = (char) ('0'); pxnman++;
                            if (pxnman % 3 == 0)
                            { txpman++;
                              buf[26-txpman] = (char) (',');
                            }
                          }
                          txpman++;
                        } while (txpman <= 26);
        return buf;
}

char * _ui64toaKAZEcomma_duplicat (
        unsigned long long val,
        char *buf,
        int radix
        )
{
                        char *p;
                        char temp;
                        int txpman;
                        int pxnman;
        x64toaKAZE_duplicat(val, buf, radix, 0);
                        p = buf;
                        do {
                        } while (*++p != '\0');
                        p--; // p points to last digit
                             // buf points to first digit
                        buf[26] = 0;
                        txpman = 1;
                        pxnman = 0;
                        while (buf <= p)
                        { temp = *p;
                          buf[26-txpman] = temp; pxnman++;
                          p--;
                          if (pxnman % 3 == 0 && buf <= p)
                          { txpman++;
                            buf[26-txpman] = (char) (',');
                          }
                          txpman++;
                        } 
        return buf+26-(txpman-1);
}

//struct stat64 statbuf_64; //struct _stati64 statbuf_64;

//void treedump(char *basePath, const int root, int WindowsFlag);
//int main(int argc, char **argv)
//{
//  char name[4096];
//  //printf("Enter path to list files: ");
//  //scanf("%s", name);
//  if (argc == 1) strcpy(name, "."); // default : current directory
//  else strcpy(name, argv[1]);
//  if ( name[strlen(name)-1] == ':' || name[strlen(name)-1] == '/' || name[strlen(name)-1] == '\\' ) {
//      name[strlen(name)] = '.';
//      name[strlen(name)+1] = 0;
//  }
//  treedump(name, 0, 0); // name should not end with ':', '/' or '\', if so then postfix the path with '.', (not 0) for Windows
//  //treedump(name, 0, !0); // name should not end with ':', '/' or '\', if so then postfix the path with '.', (not 0) for Windows
//  return 0;
//}

// (not 0) for Windows i.e. treedump(name, 0, !0)
void treedumpMORE(char *basePath, const int root, int WindowsFlag, long long *Entries, long long *Directories, long long *Files) {
    char path[4096];
    struct dirent *dp;
unsigned char PseudoGraphic1={179}; // |
unsigned char PseudoGraphic2={195}; // |-
unsigned char PseudoGraphic3={196}; // -
unsigned char PseudoGraphic4={192}; // |_
    DIR *dir;// = opendir(basePath);
    int i;

        dir = opendir(basePath);
        if (!dir) {
                printf("FILE:%s\n", basePath); 
                *Files=*Files+1;
                return;
        } else {
                if (WindowsFlag) printf("FLDR:%s\\\n", basePath);
                else printf("FLDR:%s/\n", basePath); 
                *Directories=*Directories+1;
        }
    while ((dp = readdir(dir)) != NULL) {
        if (strcmp(dp->d_name, ".") != 0 && strcmp(dp->d_name, "..") != 0) {
            //for (i=0; i<root; i++) {
            //    if (i%2 == 0) printf("%c", PseudoGraphic1);
            //    else printf(" ");
            //}
        //stat64(dp->d_name, &statbuf_64);
    //*file_size = statbuf_64.st_size;
    //if (S_ISDIR(statbuf_64.st_mode)) 
    //        printf("%c%c%s/\n", PseudoGraphic2, PseudoGraphic3, dp->d_name);
    //if (S_ISREG(statbuf_64.st_mode)) 
    //        printf("%c%c%s\n", PseudoGraphic2, PseudoGraphic3, dp->d_name);


//          printf("%s\n", dp->d_name);
            strcpy(path, basePath);
            if (WindowsFlag) strcat(path, "\\");
            else strcat(path, "/");
            strcat(path, dp->d_name);
            //printf("%s\n", path);
                        *Entries=*Entries+1;
            treedumpMORE(path, root + 2, WindowsFlag, Entries, Directories, Files);
        }
    }
    closedir(dir);
        return;
}

// (not 0) for Windows i.e. treedump(name, 0, !0)
void treedump(char *basePath, const int root, int WindowsFlag, long long *Entries) {
    char path[4096];
    struct dirent *dp;
    DIR *dir;// = opendir(basePath);
    int i;

        dir = opendir(basePath);
    if (!dir) return;
    while ((dp = readdir(dir)) != NULL) {
        if (strcmp(dp->d_name, ".") != 0 && strcmp(dp->d_name, "..") != 0) {
/*
            for (i=0; i<root; i++) {
                if (i%2 == 0) printf("%c", 179);
                else printf(" ");
            }
            printf("%c%c%s\n", 195, 196, dp->d_name);
*/
//          printf("%s\n", dp->d_name);
            strcpy(path, basePath);
            if (WindowsFlag) strcat(path, "\\");
            else strcat(path, "/");
            strcat(path, dp->d_name);
            //printf("%s\n", path);
                        *Entries=*Entries+1;
            treedump(path, root + 2, WindowsFlag, Entries);
        }
    }
    closedir(dir);
        return;
}

// 'PoolToHousePathS_REALsize' serves as function exit value - if 0 then POOL is not filled somehow, probably due to overflow
// 'PoolToHousePathS_REALsize' should be 0 at entry
void treedumpPOOL_DIRonly(char *basePath, const int root, int WindowsFlag, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize) {
    char path[4096];
    char pathMORE[4096];
    struct dirent *dp;
    DIR *dir;// = opendir(basePath);
    int i;
    char bffr[32];
    uint64_t QWORD;

        dir = opendir(basePath);
        if (!dir) {
                strcpy(pathMORE, basePath);
/*
			// Push it up [[[
                        if ( (*PoolToHousePathS_REALsize + strlen(pathMORE))+1 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, pathMORE, strlen(pathMORE)+1); //+1 to make it ASCIIZ
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + strlen(pathMORE)+1;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
			// Push it up ]]]
*/
                return;
        } else {
                strcpy(pathMORE, basePath);
                if (WindowsFlag) strcat(pathMORE, "\\");
                else strcat(pathMORE, "/");
                *Entries=*Entries+1;
			// Push it up [[[
                        if ( (*PoolToHousePathS_REALsize + strlen(pathMORE))+1 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, pathMORE, strlen(pathMORE)+1); //+1 to make it ASCIIZ
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + strlen(pathMORE)+1;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
			// Push it up ]]]
        }
    while ((dp = readdir(dir)) != NULL) {
        if (strcmp(dp->d_name, ".") != 0 && strcmp(dp->d_name, "..") != 0) {
            strcpy(path, basePath);
            if (WindowsFlag) strcat(path, "\\");
            else strcat(path, "/");
            strcat(path, dp->d_name);
            treedumpPOOL_DIRonly(path, root + 2, WindowsFlag, Entries, PoolToHousePathS, PoolToHousePathS_MAXsize, PoolToHousePathS_REALsize);
        }
    }
    closedir(dir);
    return;
}

// 'PoolToHousePathS_REALsize' serves as function exit value - if 0 then POOL is not filled somehow, probably due to overflow
// 'PoolToHousePathS_REALsize' should be 0 at entry
void treedumpPOOL_FILonly(char *basePath, const int root, int WindowsFlag, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize) {
    char path[4096];
    char pathMORE[4096];
    struct dirent *dp;
    DIR *dir;// = opendir(basePath);
    int i;
    char bffr[32];
    uint64_t QWORD;

        dir = opendir(basePath);
        if (!dir) {
                strcpy(pathMORE, basePath);
                *Entries=*Entries+1;

			// Push it up [[[
                        if ( (*PoolToHousePathS_REALsize + strlen(pathMORE))+1 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, pathMORE, strlen(pathMORE)+1); //+1 to make it ASCIIZ
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + strlen(pathMORE)+1;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
			// Push it up ]]]

                return;
        } else {
                strcpy(pathMORE, basePath);
                if (WindowsFlag) strcat(pathMORE, "\\");
                else strcat(pathMORE, "/");
/*
			// Push it up [[[
                        if ( (*PoolToHousePathS_REALsize + strlen(pathMORE))+1 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, pathMORE, strlen(pathMORE)+1); //+1 to make it ASCIIZ
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + strlen(pathMORE)+1;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
			// Push it up ]]]
*/
        }
    while ((dp = readdir(dir)) != NULL) {
        if (strcmp(dp->d_name, ".") != 0 && strcmp(dp->d_name, "..") != 0) {

            strcpy(path, basePath);
            if (WindowsFlag) strcat(path, "\\");
            else strcat(path, "/");
            strcat(path, dp->d_name);
            treedumpPOOL_FILonly(path, root + 2, WindowsFlag, Entries, PoolToHousePathS, PoolToHousePathS_MAXsize, PoolToHousePathS_REALsize);
        }
    }
    closedir(dir);
    return;
}

// 'PoolToHousePathS_REALsize' serves as function exit value - if 0 then POOL is not filled somehow, probably due to overflow
// 'PoolToHousePathS_REALsize' should be 0 at entry
void treedumpPOOL(char *basePath, const int root, int WindowsFlag, long long *Entries, char *PoolToHousePathS, long long *PoolToHousePathS_MAXsize, long long *PoolToHousePathS_REALsize) {
    char path[4096];
    char pathMORE[4096];
    struct dirent *dp;
    DIR *dir;// = opendir(basePath);
    int i;
    char bffr[32];
    int flags;
    uint64_t QWORD;
    char LastFileModification[24];
    char LastFileModificationNEW[24];

        dir = opendir(basePath);
        if (!dir) {

    // Get stats [[[
    stat64(basePath, &statbuf_64);//_stati64(dp->d_name, &statbuf_64);
    //return strlen(dp->d_name);
    //strcpy(file_name, dp->d_name);
    flags = 0;
    if (S_ISDIR(statbuf_64.st_mode)) flags = IS_DIR_FLAG;
    if (S_ISREG(statbuf_64.st_mode)) flags = IS_FILE_FLAG;

    //if (flags == IS_DIR_FLAG) printf("DR_%s/\n", basePath);
    //if (flags == IS_FILE_FLAG) printf("FL_%s\n", basePath);
    memcpy(&QWORD, &statbuf_64.st_size, 8);
    //printf("FL_SIZE:%lld\n", QWORD);
    // Get stats ]]]
              strcpy(pathMORE, _ui64toaKAZEzerocomma_duplicat(QWORD, llTOaDigits2, 10)+(26-19) ); // 19 means 19 bytes long field given i.e. 999TB max
              strcat(pathMORE, " ");

if ( strlen(_ui64toaKAZE_duplicat(QWORD, llTOaDigits, 10))>12 ) {

              strcat(pathMORE, "[TB]  ");
}
else if ( strlen(_ui64toaKAZE_duplicat(QWORD, llTOaDigits, 10))>9 ) {

              strcat(pathMORE, "[GB]  ");
}
else if ( strlen(_ui64toaKAZE_duplicat(QWORD, llTOaDigits, 10))>6 ) {

              strcat(pathMORE, "[MB]  ");
}
else if ( strlen(_ui64toaKAZE_duplicat(QWORD, llTOaDigits, 10))>3 ) {

              strcat(pathMORE, "[KB]  ");
} else {
              //strcat(pathMORE, _ui64toaKAZE_duplicat(QWORD, llTOaDigits, 10));
              strcat(pathMORE, " [B]  ");
}

              memcpy(LastFileModification, ctime((const time_t*)&statbuf_64.st_mtime), 24);
LastFileModification[7]='-';
LastFileModification[10]='_';
if ( LastFileModification[8]==' ' ) LastFileModification[8]='0';
              memcpy(LastFileModificationNEW, &LastFileModification[20], 4);
              LastFileModificationNEW[4]='_';

if ( memcmp(&LastFileModification[4], "Jan",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='1'; }
if ( memcmp(&LastFileModification[4], "Feb",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='2'; }
if ( memcmp(&LastFileModification[4], "Mar",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='3'; }
if ( memcmp(&LastFileModification[4], "Apr",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='4'; }
if ( memcmp(&LastFileModification[4], "May",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='5'; }
if ( memcmp(&LastFileModification[4], "Jun",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='6'; }
if ( memcmp(&LastFileModification[4], "Jul",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='7'; }
if ( memcmp(&LastFileModification[4], "Aug",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='8'; }
if ( memcmp(&LastFileModification[4], "Sep",3) == 0 ) { LastFileModificationNEW[5]='0'; LastFileModificationNEW[6]='9'; }
if ( memcmp(&LastFileModification[4], "Oct",3) == 0 ) { LastFileModificationNEW[5]='1'; LastFileModificationNEW[6]='0'; }
if ( memcmp(&LastFileModification[4], "Nov",3) == 0 ) { LastFileModificationNEW[5]='1'; LastFileModificationNEW[6]='1'; }
if ( memcmp(&LastFileModification[4], "Dec",3) == 0 ) { LastFileModificationNEW[5]='1'; LastFileModificationNEW[6]='2'; }

              LastFileModificationNEW[7]='/';
              memcpy(&LastFileModificationNEW[8], &LastFileModification[4], 15);
              LastFileModificationNEW[23]='\0';
              strcat(pathMORE, LastFileModificationNEW);
              strcat(pathMORE, "  ");

/*
Function SwapAndRemove$ (NoNeedOfDayOfWeek_HasToBeSortable$)
        InsertZERO$ = NoNeedOfDayOfWeek_HasToBeSortable$
        If Mid$(NoNeedOfDayOfWeek_HasToBeSortable$, 9, 1) = " " Then Mid$(InsertZERO$, 9, 1) = "0"
        Mid$(InsertZERO$, 11, 1) = "_"
        Mid$(InsertZERO$, 8, 1) = "-"
        'Cls: Print "["; Right$(InsertZERO$, 4) + "_" + Month2Num$(Mid$(InsertZERO$, 5, 3)) + "/" + Mid$(InsertZERO$, 5, 24 - 4 - (4 + 1)); "]": _Display: _Delay 4
        SwapAndRemove$ = Right$(InsertZERO$, 4) + "_" + Month2Num$(Mid$(InsertZERO$, 5, 3)) + "/" + Mid$(InsertZERO$, 5, 24 - 4 - (4 + 1))
End Function

Function Month2Num$ (NoNeedOfDayOfWeek_HasToBeSortable$)
        Select Case NoNeedOfDayOfWeek_HasToBeSortable$
                Case "Jan"
                        Month2Num$ = "01"
                Case "Feb"
                        Month2Num$ = "02"
                Case "Mar"
                        Month2Num$ = "03"
                Case "Apr"
                        Month2Num$ = "04"
                Case "May"
                        Month2Num$ = "05"
                Case "Jun"
                        Month2Num$ = "06"
                Case "Jul"
                        Month2Num$ = "07"
                Case "Aug"
                        Month2Num$ = "08"
                Case "Sep"
                        Month2Num$ = "09"
                Case "Oct"
                        Month2Num$ = "10"
                Case "Nov"
                        Month2Num$ = "11"
                Case "Dec"
                        Month2Num$ = "12"
        End Select
End Function

*/
              strcat(pathMORE, basePath);
              *Entries=*Entries+1;
//QWORD= 9123123123;
//sprintf(bffr, "%lld", QWORD);
//strcat(pathMORE, bffr);


			// Push it up [[[
                        if ( (*PoolToHousePathS_REALsize + strlen(pathMORE))+1 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, pathMORE, strlen(pathMORE)+1); //+1 to make it ASCIIZ
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + strlen(pathMORE)+1;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
			// Push it up ]]]


                return;
        } else {
                strcpy(pathMORE, basePath);
                if (WindowsFlag) strcat(pathMORE, "\\");
                else strcat(pathMORE, "/");


/*
			// Push it up [[[
                        if ( (*PoolToHousePathS_REALsize + strlen(pathMORE))+1 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, pathMORE, strlen(pathMORE)+1); //+1 to make it ASCIIZ
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + strlen(pathMORE)+1;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
			// Push it up ]]]
*/

        }
    while ((dp = readdir(dir)) != NULL) {
        if (strcmp(dp->d_name, ".") != 0 && strcmp(dp->d_name, "..") != 0) {
/*
            for (i=0; i<root; i++) {
                if (i%2 == 0) printf("%c", 179);
                else printf(" ");
            }
            printf("%c%c%s\n", 195, 196, dp->d_name);
*/
//          printf("%s\n", dp->d_name);
            strcpy(path, basePath);
            if (WindowsFlag) strcat(path, "\\");
            else strcat(path, "/");
            strcat(path, dp->d_name);

/*
            //printf("%s\n", path); //This goes to console
                        if ( (*PoolToHousePathS_REALsize + strlen(pathMORE))+1 < *PoolToHousePathS_MAXsize ) {
                                memcpy(PoolToHousePathS+*PoolToHousePathS_REALsize, pathMORE, strlen(pathMORE)+1); //+1 to make it ASCIIZ
                                *PoolToHousePathS_REALsize = *PoolToHousePathS_REALsize + strlen(pathMORE)+1;
                        } else {
                                *PoolToHousePathS_REALsize=0;
                                return;
                        }
*/
                        //*Entries=*Entries+1;
            treedumpPOOL(path, root + 2, WindowsFlag, Entries, PoolToHousePathS, PoolToHousePathS_MAXsize, PoolToHousePathS_REALsize);
}
    }
    closedir(dir);
        return;
}
